# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'ScrambleUnscramble.ui'
#
# Created by: PyQt5 UI code generator 5.15.1
#
# WARNING: Any manual changes made to this file will be lost when pyuic5 is
# run again.  Do not edit this file unless you know what you are doing.


from PyQt5 import QtCore, QtGui, QtWidgets
import random



class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(648, 600)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        self.verticalLayout = QtWidgets.QVBoxLayout(self.centralwidget)
        self.verticalLayout.setObjectName("verticalLayout")
        self.horizontalLayout = QtWidgets.QHBoxLayout()
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.Scorelabel = QtWidgets.QLabel(self.centralwidget)
        self.Scorelabel.setMinimumSize(QtCore.QSize(90, 40))
        self.Scorelabel.setMaximumSize(QtCore.QSize(80, 80))
        font = QtGui.QFont()
        font.setPointSize(25)
        self.Scorelabel.setFont(font)
        self.Scorelabel.setObjectName("Scorelabel")
        self.horizontalLayout.addWidget(self.Scorelabel)
        self.ScoreValue = QtWidgets.QLabel(self.centralwidget)
        self.ScoreValue.setMinimumSize(QtCore.QSize(0, 0))
        font = QtGui.QFont()
        font.setPointSize(25)
        self.ScoreValue.setFont(font)
        self.ScoreValue.setObjectName("ScoreValue")
        self.horizontalLayout.addWidget(self.ScoreValue)
        self.verticalLayout.addLayout(self.horizontalLayout)
        self.Scrambledsentence = QtWidgets.QLabel(self.centralwidget)
        font = QtGui.QFont()
        font.setPointSize(21)
        self.Scrambledsentence.setFont(font)
        self.Scrambledsentence.setObjectName("Scrambledsentence")
        self.verticalLayout.addWidget(self.Scrambledsentence)
        self.unscrambleanswer = QtWidgets.QLineEdit(self.centralwidget)
        self.unscrambleanswer.setMaximumSize(QtCore.QSize(16777215, 50))
        font = QtGui.QFont()
        font.setPointSize(17)
        self.unscrambleanswer.setFont(font)
        self.unscrambleanswer.setObjectName("unscrambleanswer")
        self.verticalLayout.addWidget(self.unscrambleanswer)
        self.hint = QtWidgets.QLabel(self.centralwidget)
        font = QtGui.QFont()
        font.setPointSize(14)
        self.hint.setFont(font)
        self.hint.setText("")
        self.hint.setObjectName("hint")
        self.verticalLayout.addWidget(self.hint)
        self.SubmitButton = QtWidgets.QPushButton(self.centralwidget)
        font = QtGui.QFont()
        font.setPointSize(25)
        self.SubmitButton.setFont(font)
        self.SubmitButton.setObjectName("SubmitButton")
        self.verticalLayout.addWidget(self.SubmitButton)
        self.nextbutton = QtWidgets.QPushButton(self.centralwidget)
        font = QtGui.QFont()
        font.setPointSize(25)
        self.nextbutton.setFont(font)
        self.nextbutton.setObjectName("nextbutton")
        self.verticalLayout.addWidget(self.nextbutton)
        MainWindow.setCentralWidget(self.centralwidget)

        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)

    def retranslateUi(self, MainWindow):
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "Scramble Unscramble"))
        self.Scorelabel.setText(_translate("MainWindow", "Score :"))
        self.ScoreValue.setText(_translate("MainWindow", "0"))
        #self.Scrambledsentence.setText(_translate("MainWindow", "My teacher is my dad"))
        self.SubmitButton.setText(_translate("MainWindow", "Submit"))
        self.nextbutton.setText(_translate("MainWindow", "Next"))
        self.scorevalue = 0
        self.numberOfProblems = 20
        self.ScrambleSentences = [self.numberOfProblems]
        self.createList()
        self.index = -1
        self.nextbutton.clicked.connect(self.displayScramble)
        self.SubmitButton.clicked.connect(self.verify)
        
    def displayScramble(self):
        self.SubmitButton.setEnabled(True)
        self.unscrambleanswer.clear()
        self.index += 1
        if self.index == self.numberOfProblems-1:
            self.nextbutton.setEnabled(False)
            QtWidgets.QMessageBox.about(self.centralwidget,"Finished","Congratulations you finished it")
            self.Scrambledsentence.clear()
        if self.index < self.numberOfProblems:
            item = self.ScrambleSentences[self.index]
            if type(item) != int:
                self.Scrambledsentence.setText(str(item.shuffleOrginalStr()))
                
    def verify(self):
        self.SubmitButton.setEnabled(False)
        item = self.ScrambleSentences[self.index]
        if type(item) != int:
            if self.unscrambleanswer.text().lower().replace(" ","") == item.originalstr.lower().replace(" ",""):
                self.scorevalue += 1
                self.ScoreValue.setText (str(self.scorevalue))
                QtWidgets.QMessageBox.about(self.centralwidget,"answer","Correct")
            else:
                QtWidgets.QMessageBox.about(self.centralwidget,"answer","incorrect")
             
        
    def createList(self):
        self.ScrambleSentences.append(Scramble("I Went to New Orleans"))
        self.ScrambleSentences.append(Scramble("There is a fish in the bowl"))
        self.ScrambleSentences.append(Scramble("I love Kolkata"))
        self.ScrambleSentences.append(Scramble("I live with my parents"))
        self.ScrambleSentences.append(Scramble("Louis Armstrong was born in New Orleans"))
        self.ScrambleSentences.append(Scramble("I love to do programming"))
        self.ScrambleSentences.append(Scramble("There is a man standing right there"))
        self.ScrambleSentences.append(Scramble("Swami Vivekananda was a great Philosopher"))
        self.ScrambleSentences.append(Scramble("I can read a book"))
        self.ScrambleSentences.append(Scramble("I love ice cream"))
        self.ScrambleSentences.append(Scramble("The king of the jungle is the lion"))
        self.ScrambleSentences.append(Scramble("Nile is the longest river"))
        self.ScrambleSentences.append(Scramble("Delhi is the capital of india"))
        self.ScrambleSentences.append(Scramble("Subhash Chandra Bose was a great freedom fighter"))
        self.ScrambleSentences.append(Scramble("i went to Shimla"))
        self.ScrambleSentences.append(Scramble("we are back in the show"))
        self.ScrambleSentences.append(Scramble("William Shakespeare was a British Author"))
        self.ScrambleSentences.append(Scramble("I love the Indian Army"))
        self.ScrambleSentences.append(Scramble("to succeed you should have the fire in the belly"))
        self.ScrambleSentences.append(Scramble("lincoln Abraham was the president of America"))
        random.shuffle(self.ScrambleSentences)


class Scramble:
    def __init__(self, originalstr):
        self.originalstr = originalstr
    def shuffleOrginalStr(self):
        listOriginalstr = self.originalstr.split()
        random.shuffle(listOriginalstr)
        return str(" ".join(listOriginalstr))
       
        
if __name__ == "__main__":
    import sys
    app = QtWidgets.QApplication(sys.argv)
    MainWindow = QtWidgets.QMainWindow()
    ui = Ui_MainWindow()
    ui.setupUi(MainWindow)
    MainWindow.show()
    sys.exit(app.exec_())
